=== debian/changelog ===
tlfloat (1.15.0-2) unstable; urgency=medium

  * d/control: remove M-A: same from libtlfloat-dev due to file conflicts.
  * d/control: bump std-ver to 4.7.3 (no changes needed).
  * d/patches: add patch to fix FTBFS on ppc64el (closes: #1129014).

 -- Shengqi Chen <harry@debian.org>  Thu, 26 Feb 2026 15:39:35 +0800

tlfloat (1.15.0-1) unstable; urgency=medium

  * Initial upload (closes: #1118721).

 -- Shengqi Chen <harry@debian.org>  Tue, 28 Oct 2025 21:32:34 +0800
