=== debian/control ===
Source: tlfloat
Section: math
Standards-Version: 4.7.3
Maintainer: Shengqi Chen <harry@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 ninja-build,
 architecture-is-64-bit,
 libmpfr-dev <!nocheck>,
 doxygen <!nodoc>,
 graphviz <!nodoc>,
Homepage: https://github.com/shibatch/tlfloat
Vcs-Git: https://salsa.debian.org/science-team/tlfloat.git
Vcs-Browser: https://salsa.debian.org/science-team/tlfloat

Package: libtlfloat1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++ template library for floating point operations (shared library)
 tlfloat implements C++ classes with which half, single, double, quadruple
 and octuple precision IEEE 754 floating point numbers can be operated.
 .
 This package contains libtlfloat shared library.

Package: libtlfloat-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libtlfloat1 (= ${binary:Version})
Suggests: libtlfloat-doc
Description: C++ template library for floating point operations (development files)
 tlfloat implements C++ classes with which half, single, double, quadruple
 and octuple precision IEEE 754 floating point numbers can be operated.
 .
 This package contains development files for libtlfloat.

Package: libtlfloat-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Depends: ${misc:Depends}
Description: C++ template library for floating point operations (documentation)
 tlfloat implements C++ classes with which half, single, double, quadruple
 and octuple precision IEEE 754 floating point numbers can be operated.
 .
 This package contains API documentation for libtlfloat.
